// DlgAlarmChanList.cpp : ʵļ
//

#include "stdafx.h"
#include "EHomeDemo.h"
#include "DlgAlarmChanList.h"


// CDlgAlarmChanList Ի

IMPLEMENT_DYNAMIC(CDlgAlarmChanList, CDialog)

CDlgAlarmChanList::CDlgAlarmChanList(CWnd* pParent /*=NULL*/)
: CDialog(CDlgAlarmChanList::IDD, pParent)
{
    m_strDlgTitle = _T("");
    m_byDataType = (BYTE)-1;
    m_byNum = 0;
    memset(m_byAnalogAlarmOut, 0, MAX_ANALOG_ALARMOUT);
    memset(m_byAnalogAlarmChan, 0, MAX_ANALOG_CHANNUM);
    memset(m_byDigitalAlarmChan, 0, MAX_DIGIT_CHANNUM);
}

CDlgAlarmChanList::~CDlgAlarmChanList()
{
}

void CDlgAlarmChanList::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_TREE1, m_treeAlarmChan);
}


BEGIN_MESSAGE_MAP(CDlgAlarmChanList, CDialog)
    ON_BN_CLICKED(IDC_BTN_OK, &CDlgAlarmChanList::OnBnClickedBtnOk)
    ON_BN_CLICKED(IDC_BTN_CANCEL, &CDlgAlarmChanList::OnBnClickedBtnCancel)
    ON_NOTIFY(NM_CLICK, IDC_TREE1, &CDlgAlarmChanList::OnNMClickTree1)
END_MESSAGE_MAP()


// CDlgAlarmChanList Ϣ

BOOL CDlgAlarmChanList::OnInitDialog()
{
    CDialog::OnInitDialog();

    // TODO:  ڴӶĳʼ
    SetWindowText(m_strDlgTitle);
    InitTreeList();

    return TRUE;  // return TRUE unless you set the focus to a control
    // 쳣: OCX ҳӦ FALSE
}

void CDlgAlarmChanList::InitTreeList()
{
    m_treeAlarmChan.ModifyStyle(TVS_CHECKBOXES, 0);
    m_treeAlarmChan.ModifyStyle(0, TVS_CHECKBOXES);
    HTREEITEM hTreeNode = NULL;
    CString strItemText = _T("");
    BYTE byItemData = 0;
    if (m_byDataType == 0)
    {
        for (int iNodeCnt = 0; iNodeCnt < MAX_ANALOG_ALARMOUT; iNodeCnt++)
        {
            strItemText.Format("AnalogAlarmOut %d", iNodeCnt + 1);
            byItemData = (BYTE)iNodeCnt;
            hTreeNode = m_treeAlarmChan.InsertItem(strItemText, TVI_ROOT, TVI_LAST);
            m_treeAlarmChan.SetItemData(hTreeNode, byItemData);
            if (m_byAnalogAlarmOut[iNodeCnt] == 1)
            {
                m_treeAlarmChan.SetCheck(hTreeNode);
            }
        }
    }
    else if (m_byDataType == 1)
    {
        for (int iNodeCnt = 0; iNodeCnt < MAX_ANALOG_CHANNUM; iNodeCnt++)
        {
            strItemText.Format("AnalogChan %d", iNodeCnt + 1);
            byItemData = (BYTE)iNodeCnt;
            hTreeNode = m_treeAlarmChan.InsertItem(strItemText, TVI_ROOT, TVI_LAST);
            m_treeAlarmChan.SetItemData(hTreeNode, byItemData);
            if (m_byAnalogAlarmChan[iNodeCnt] == 1)
            {
                m_treeAlarmChan.SetCheck(hTreeNode);
            }
        }
    }
    else
    {
        for (int iNodeCnt = 0; iNodeCnt < MAX_DIGIT_CHANNUM; iNodeCnt++)
        {
            strItemText.Format("DigitalChan %d", iNodeCnt + 1);
            byItemData = (BYTE)iNodeCnt;
            hTreeNode = m_treeAlarmChan.InsertItem(strItemText, TVI_ROOT, TVI_LAST);
            m_treeAlarmChan.SetItemData(hTreeNode, byItemData);
            if (m_byDigitalAlarmChan[iNodeCnt] == 1)
            {
                m_treeAlarmChan.SetCheck(hTreeNode);
            }
        }
    }
}

void CDlgAlarmChanList::GetDataFromTreeList()
{
    HTREEITEM hTreeNode = m_treeAlarmChan.GetRootItem();
    HTREEITEM hNextSibling = hTreeNode;
    BOOL bChecked = FALSE;
    int iCheckedCnt = 0;
    while (hNextSibling)
    {
        BYTE byItemData = (BYTE)m_treeAlarmChan.GetItemData(hNextSibling);
        if (m_byDataType == 0)
        {
            bChecked = m_treeAlarmChan.GetCheck(hNextSibling);
            if (bChecked)
            {
                if (iCheckedCnt++ >= m_byNum)
                {
                    break;
                }
            }
            m_byAnalogAlarmOut[byItemData] = (BYTE)bChecked;
        }
        else if (m_byDataType == 1)
        {
            bChecked = m_treeAlarmChan.GetCheck(hNextSibling);
            if (bChecked)
            {
                if (iCheckedCnt++ >= m_byNum)
                {
                    break;
                }
            }
            m_byAnalogAlarmChan[byItemData] = (BYTE)bChecked;
        }
        else
        {
            bChecked = m_treeAlarmChan.GetCheck(hNextSibling);
            if (bChecked)
            {
                if (iCheckedCnt++ >= m_byNum)
                {
                    break;
                }
            }
            m_byDigitalAlarmChan[byItemData] = (BYTE)bChecked;
        }
        hNextSibling = m_treeAlarmChan.GetNextSiblingItem(hNextSibling);
    }
}

void CDlgAlarmChanList::OnBnClickedBtnOk()
{
    // TODO: ڴӿؼ֪ͨ
    GetDataFromTreeList();
    return CDialog::OnOK();
}

void CDlgAlarmChanList::OnBnClickedBtnCancel()
{
    // TODO: ڴӿؼ֪ͨ
    return CDialog::OnCancel();
}

void CDlgAlarmChanList::OnNMClickTree1(NMHDR *pNMHDR, LRESULT *pResult)
{
    // TODO: ڴӿؼ֪ͨ
    UN_REFERENCED_PARAMETER(pNMHDR)
    CPoint ptCursor;
    GetCursorPos(&ptCursor);
    m_treeAlarmChan.ScreenToClient(&ptCursor);
    HTREEITEM hClickedNode = m_treeAlarmChan.HitTest(ptCursor);
    if (hClickedNode)
    {
        m_treeAlarmChan.SelectItem(hClickedNode);
    }

    *pResult = 0;
}
